package com.pate;




import android.view.View.OnTouchListener;
import java.util.Random;
import android.app.Activity;
import android.os.Handler;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ImageView;


import com.pate.NappulaLista;
public class Speedtest extends Activity {
	private TextView pisteet;
	private Random rand_gen = new Random();
	NappulaLista painallukset  = new NappulaLista();
	public static ImageView[] buttons = {null, null, null, null}; //pelattavat nappulat
	int edellinen_nappi=5;	//viimeisin nappi jotta seuraava ei ole sama
	double delay=1000;		//aikan nappuloiden syttymisen vlill
	int hingscore=0;
	int score=0;

	boolean gamerunning=false;
	
	Handler h = new Handler();
	
	private int uusiNappi(int edellinen)
    {
		int arpa;
		int uusi_nappi;
		if (edellinen<4)
		{
			arpa = rand_gen.nextInt(3)+1;
			uusi_nappi = (edellinen + arpa)%4;
		}
		else
		{
			uusi_nappi = rand_gen.nextInt(3)+1;
		}
    	return uusi_nappi;
    }
	private final OnTouchListener Listener1 = new OnTouchListener() {
		public boolean onTouch(View v, MotionEvent event){
			
			if (gamerunning && event.getAction()==MotionEvent.ACTION_DOWN)
			{
				if (painallukset.getFirst()==0)
				{
					++score;
					buttonPress(0);
					updateCounter();
				}
				else
				{
					lopetapeli();
				}
			}
			else if (gamerunning && event.getAction()==MotionEvent.ACTION_UP)
			{
				buttonOff(0);
			}
			return false;
		}
	};
	private final OnTouchListener Listener2 = new OnTouchListener() {
		public boolean onTouch(View v, MotionEvent event){
			
			if (gamerunning && event.getAction()==MotionEvent.ACTION_DOWN){
				if (painallukset.getFirst()==1){
					++score;
					buttonPress(1);
					updateCounter();
				}
				else{
					lopetapeli();
				}
			}
			else if (gamerunning && event.getAction()==MotionEvent.ACTION_UP){
				buttonOff(1);
			}
			return false;
		}
	};
	private final OnTouchListener Listener3 = new OnTouchListener() 
	{
		public boolean onTouch(View v, MotionEvent event){
			
			if (gamerunning && event.getAction()==MotionEvent.ACTION_DOWN)
			{
				if (painallukset.getFirst()==2)
				{
					++score;
					buttonPress(2);
					updateCounter();
				}
				else
				{
					lopetapeli();
				}
			}
			else if (gamerunning && event.getAction()==MotionEvent.ACTION_UP)
			{
				buttonOff(2);
			}
			return false;
		}
	};
	private final OnTouchListener Listener4 = new OnTouchListener() 
	{
		public boolean onTouch(View v, MotionEvent event)
		{
			if (gamerunning && event.getAction()==MotionEvent.ACTION_DOWN)
			{
				if (painallukset.getFirst()==3)
				{
					++score;
					buttonPress(3);
					updateCounter();
				}
				else
				{
					lopetapeli();
				}
			}
			else if (gamerunning && event.getAction()==MotionEvent.ACTION_UP)
			{
				
				buttonOff(3);
			}
			return false;
		}
	};

	private final OnClickListener AloitaLopeta = new OnClickListener() 
	{
		public void onClick(View v){
			if (v.getId()==5)aloitapeli();	
			else if (v.getId()==6)finish();	
		}
	};
	Runnable taskLightButton = new Runnable() 
	{
		public void run() 
		{
			if (gamerunning)
			{
				if (edellinen_nappi<4) buttonOff(edellinen_nappi);//edellinen nappi sammuu
				edellinen_nappi=uusiNappi(edellinen_nappi);
				painallukset.setLast(edellinen_nappi);
				if (painallukset.isfull()) lopetapeli();//lopetetaan peli jos nappeja ei paineta
				buttonOn(edellinen_nappi);//uusinappi syttyy
				delay=0.995*delay;
			}
			h.postDelayed(this, Math.round(delay));
		}
	};
	public void lopetapeli()
	{
		gamerunning=false;
		painallukset.alusta();
		buttonOn(0);
		buttonOn(1);
		buttonOn(2);
		buttonOn(3);
	}
	public void aloitapeli()
	{
		if(gamerunning == false)
		{
			buttonOff(0);
			buttonOff(1);
			buttonOff(2);
			buttonOff(3);
			score=0;
			updateCounter();
			gamerunning=true;
			delay=1000;
		}
	}

    private void updateCounter() {
        pisteet.setText(""+score);
    }

    private void buttonPress(int nappi)
    {
    	switch(nappi)
    	{
    	case 0:
    		buttons[0].setImageResource(R.drawable.button_green_pressed);
    		break;
    	case 1:
    		buttons[1].setImageResource(R.drawable.button_red_pressed);
    		break;
    	case 2:
    		buttons[2].setImageResource(R.drawable.button_yellow_pressed);
    		break;
    	case 3:
    		buttons[3].setImageResource(R.drawable.button_blue_pressed);
    		break;
    	}
    	
    }
    private void buttonOn(int nappi)
    {
    	switch(nappi)
    	{
    	case 0:
    		buttons[0].setImageResource(R.drawable.button_green_on);
    		break;
    	case 1:
    		buttons[1].setImageResource(R.drawable.button_red_on);
    		break;
    	case 2:
    		buttons[2].setImageResource(R.drawable.button_yellow_on);
    		break;
    	case 3:
    		buttons[3].setImageResource(R.drawable.button_blue_on);
    		break;
    	}
    	
    }
    private void buttonOff(int nappi)
    {
    	switch(nappi)
    	{
    	case 0:
    		buttons[0].setImageResource(R.drawable.button_green_off);
    		break;
    	case 1:
    		buttons[1].setImageResource(R.drawable.button_red_off);
    		break;
    	case 2:
    		buttons[2].setImageResource(R.drawable.button_yellow_off);
    		break;
    	case 3:
    		buttons[3].setImageResource(R.drawable.button_blue_off);
    		break;
    	}
    }

    @Override protected void onPause() {
        super.onPause();
        lopetapeli();
    }

	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button aloita = (Button)findViewById(R.id.Aloitus);
        Button lopeta = (Button)findViewById(R.id.Lopeta);
        aloita.setId(5);
        lopeta.setId(6);
        ImageView button1 = (ImageView)findViewById(R.id.Button01);
        ImageView button2 = (ImageView)findViewById(R.id.Button02);
        ImageView button3 = (ImageView)findViewById(R.id.Button03);
        ImageView button4 = (ImageView)findViewById(R.id.Button04);
        
        
        button1.setOnTouchListener(Listener1);
        button2.setOnTouchListener(Listener2);
        button3.setOnTouchListener(Listener3);
        button4.setOnTouchListener(Listener4);
        lopeta.setOnClickListener(AloitaLopeta);
        aloita.setOnClickListener(AloitaLopeta);

        buttons[0] = button1;
        buttons[1] = button2;
        buttons[2] = button3;
        buttons[3] = button4;
		buttonOff(0);
		buttonOff(1);
		buttonOff(2);
		buttonOff(3);

        

        pisteet = (TextView) findViewById(R.id.Current_score);
        pisteet.setText(""+score);
        pisteet.setEnabled(false);

        taskLightButton.run();
	}
}


